indexing
   title:       "presents an example of DATE class usage";
   cluster:     "timedate/examples/test_dat [timedate/examples/test_dat]";
   project:     "The Universal Time & Date UTDC";
   copyright:   "SIG Computer, 1995";
   author:      "Alexei Simonov (alex@eiffel.ru)";
   original:    22,Sep,95;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   license:     "GNU Library GPL - see included readme file";
   extrnl_name: "test_dat.e";

class TEST_DATE

   creation
      make

   feature

      f : SCIENTIFIC_FORMAT
      ld         : LONG_DURATION
      d1, d2     : DATE

      time_tools : TIME_TOOLS
      out : SCIENTIFIC_FORMAT

      test_two_date (year1, month1, day1, year2, month2, day2 : INTEGER) is
         do

            !!d1.set_date (year1, month1, day1);
            !!d2.set_date (year2, month2, day2);
            !!time_tools;
            f.print("--------------------------------------------------------%N")
            f.printf("First date is !a (!s). ",
                   << d1, time_tools.day_name (d1.day_of_week) >> )
            f.printf("Second date is !a (!s).%N",
                   << d2, time_tools.day_name (d2.day_of_week) >> )

            if d1 < d2 then
               ld := d2.difference (d1);
            else
               ld := d1.difference (d2);
            end -- if

            -- Note that duration is measured in units
            -- So month is 30 days
            -- And year is 12 months (360 days)

            f.printf("Difference is !i years !i month !i days. ",
                   << ld.year_part, ld.month_part, ld.day_part >> )

            f.printf("Distance is !10.0f days%N", << ld.as_days >> )

            if d1 - ld < d2 then
               d1 := d1 + ld;
            else
               d2 := d2 + ld;
            end -- if

            if not d1.is_equal (d2) then f.print("%NError!%N") end
         end -- test_two_date

      test_now_2000 is
         do
            !! d1.set_date (2000, 1, 1);
            !! d2.set_to_now;

            test_two_date (d1.year_part, d1.month_part, d1.day_part,
                           d2.year_part, d2.month_part, d2.day_part );

         end -- test_now_2000

      make is
         do
            !!f.make
            test_two_date (1995, 9, 18, 1995, 9, 19);
            test_two_date (1995, 9, 18, 1995, 10, 18);
            test_two_date (1995, 9, 18, 1996, 9, 18);
            test_two_date (1976, 2, 29, 1976, 12, 31);
            test_two_date (1974, 2, 28, 1969, 5, 15);
            test_two_date (1974, 1, 24, 1974, 5, 9);
            test_now_2000;
         end -- make

   end --  class TEST_DATE

