indexing
   title:       "presents an example of DURATION class usage";
   cluster:     "timedate/examples/test_dur [timedate/examples/test_dur]";
   project:     "The Universal Time & Date UTDC";
   copyright:   "SIG Computer, 1995";
   author:      "Alexei Simonov (alex@eiffel.ru)";
   original:    22,Sep,95;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   license:     "GNU Library GPL - see included readme file";
   extrnl_name: "test_dur.e";

class TEST_DURATION

   inherit
      IO_USER

   creation
      make

   feature

      dd1, dd2, dd3, dd4 : DURATION


      test_duration is

         do
            put_nl ("Initialize duration -------------");
            !! dd1.set ( 995, 6, 10, 10, 20, 30.1);
            !! dd2.set_from_compressed (358385, 469230100);
            !! dd3.set_from_compressed (-358395, 394769900);
            !! dd4.set_from_compressed (358395, -394769900)

            put_nl (x.s_duration (dd1)); -- print variable
            put_nl (x.s_duration (dd2));
            put_nl (x.s_duration (dd3));
            put_nl (x.s_duration (dd4));
            put_nl (x.s_duration (dd1 + dd2 - dd3 + dd4));
            put_nl (x.s_duration (dd1.multiply_by (4)));

            -- compare the two dates
            mio.put_boolean( dd1.plus (dd2) < dd2 + dd3);
            mio.put_new_line; mio.put_new_line;

            put_nl ("Some magic calculation with long_duration ----");
            dd3 := dd2.multiply_by (dd4.ratio(dd1.divide_by (2))) - dd1;
            put_nl (x.s_duration (dd3));
            mio.put_real (dd3.as_years); put_nl (" as years ");
            mio.put_real (dd3.as_months); put_nl (" as months");
            mio.put_real (dd3.as_days); put_nl (" as days");
            mio.put_real (dd3.as_hours); put_nl (" as hours");
            mio.put_real (dd3.as_minutes); put_nl (" as minutes");
            mio.put_real (dd3.as_seconds); put_nl (" as seconds");
            mio.put_new_line
         end -- test_duration


      test_two_duration (days1, ms1, days2, ms2 : INTEGER) is

         do
            !! dd1.set_from_compressed (days1, ms1);
            !! dd2.set_from_compressed (days2, ms2);
            put_nl (x.s_duration (dd1)); -- print variable
            put_nl (x.s_duration (dd2));
            put_nl (x.s_duration (dd1+dd2));

            if dd1 < dd2 then
               dd3 := dd2 - dd1;
            else
               dd3 := dd1 - dd2;
            end -- if

            put_nl (x.s_duration (dd3));
            mio.put_real ( dd1.ratio (dd2)); put_nl (" dd1 ratio dd2 ");
            mio.put_real ( dd2.ratio (dd1)); put_nl (" dd2 ratio dd1 ");
         end -- test_two_duration

      make is

         do
            test_duration;
            test_two_duration ( 200, 10000, 20, 1000 );
            test_two_duration ( 500, 500000, -250, -250000 );
            test_two_duration ( 10000, 222222, -10000, -222222);
         end -- make

   end --  class TEST_DURATION

