indexing
   title:       "presents an example of TIME class usage";
   cluster:     "timedate/examples/test_tim [timedate/examples/test_tim]";
   project:     "The Universal Time & Date UTDC";
   copyright:   "SIG Computer, 1995";
   author:      "Alexei Simonov (alex@eiffel.ru)";
   original:    22,Sep,95;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   license:     "GNU Library GPL - see included readme file";
   extrnl_name: "test_tim.e";

class TEST_TIME

   inherit
      IO_USER

   creation
      make

   feature

      sd             : SHORT_DURATION
      t1, t2, t3, t4 : TIME
      ts             : TIMESTAMP

      time_tools     : TIME_TOOLS

      test_time_calculation is

         do
            put_nl ("Print some times ------------------");
            !! t1.set_time (1, 0, 10.0); -- one hour, ten seconds
            !! t2.set_from_milliseconds (3601000);
            !! t3.set_time (20, 30, 0); -- twenty hours, 30 minutes
            put_nl (x.s_time (t1));
            put_nl (x.s_time (t2)); -- ???  should be one hour, one second
            put_nl (x.s_time (t3));

            sd := t3.difference (t1);
            put_nl (x.s_short_duration (sd)); --
            mio.put_real (sd.as_hours); put_nl (" as hours");
            mio.put_real (sd.as_minutes); put_nl (" as minutes");
            mio.put_real (sd.as_seconds); put_nl (" as seconds");

            t2 := t1 + sd;
            put_nl (x.s_time (t2)); -- should be equal to t3 above

            !! sd.set_time (500, 0, 0) -- how many days are 500 hours ?
            !! t1.clear
            t1 := t1 + sd;
            ts ?= t1
            if ts = void then
               put_nl ("Error - must be TIMESTAMP")
            else
               put_nl (x.s_timestamp (ts));
            end -- if

            !! sd.set_time (-500, 0, 0)
            !! t4.clear
            t4 := t4 - sd;
            ts ?= t4
            if ts = void then
               put_nl ("Error - must be TIMESTAMP")
            else
               put_nl (x.s_timestamp (ts));
            end -- if
            put_nl (" t2 < t3 ");
            mio.put_boolean (t2 < t3);
            mio.put_new_line;
            put_nl (" t1 < t4 ");
            mio.put_boolean (t1 < t4);
            mio.put_new_line;
         end -- test_time_calculation

      test_time_loop is

         local
            i : INTEGER;
         do
            !! t1.set_to_now;
            put_nl (x.s_time (t1));

            from
               i := 1;
            until
               i >= 10000000
            loop
               i := i + 1;
            end -- from

            !! t2.set_to_now;
            put_nl (x.s_time (t2));
            sd := t2.difference (t1);
            mio.put_real (sd.as_hours); put_nl (" as hours");
            mio.put_real (sd.as_minutes); put_nl (" as minutes");
            mio.put_real (sd.as_seconds); put_nl (" as seconds");
         end -- test_time_loop

      make is

         do
            test_time_calculation;
            test_time_loop;
         end -- make

   end --  class TEST_TIME

